# -*- coding: utf-8 -*-

"""
Module implementing MainWindow.
"""
from PyQt4 import QtCore, QtGui
from PyQt4.QtGui import QMainWindow 
from PyQt4.QtCore import pyqtSignature

from Ui_fenetre import Ui_MainWindow
import re 


class MainWindow(QMainWindow, Ui_MainWindow):
    """
    Class documentation goes here.
    """
    def __init__(self, parent = None):
        """
        Constructor
        """
        QMainWindow.__init__(self, parent)
        self.setupUi(self)

   
    @pyqtSignature("")
    def on_pushButton_clicked(self):

        """
        charger l'URL indiqué dans lineedit.
        """
        url = unicode(self.lineEdit.text())
        if not url.startswith("http://"): url="http://"+url
        self.webView.setUrl(QtCore.QUrl(url))
        self.statusbar.setText("loading "+url)
        
        
     
    @pyqtSignature("")
    def on_lineEdit_returnPressed(self):
        """
        Slot documentation goes here.
        """
        self.on_pushButton_clicked()

    def on_webView_loadFinished (self):
        """
        quand le chargement est terminé.
        """
        self.statusbar.setText(unicode(self.webView.url().toString())+" loaded")
        html = unicode(self.webView.page().mainFrame().toHtml())
        text = self.nettoie(html)
        self.textEdit.setText(text)
        langue=self.langue(text)
        #TODO:
        #langue=self.langue(text)
        self.laLangueResultat.setText(langue)
        

      
    def langue(self, text):  
        
        langues = {"all":"allemand","en":"anglais","fr":u"français", "it":"italien", "esp":"espagnol", "portu":"portugais", "hong":"hongrois",  "su":"finnois",  "dansk":"danois",  "sv":u"suédois", "eesti":"estonien",  "esper":"esperanto", "is":"islandais",  "lt":"lituanien",  "lv":"letton", "no":u"norvégien",  "slovak":"slovaque",  "croate":"croate",  "roumain":"roumain", "pl":"polonais",  "czech":"tchèque",  "irga":"gaélique irlandais",  "maltais":"maltais",  "neerd":"neerlandais",  "turc":"turc", "slovene":"slovene", "venitien":"venitien"}

        dicoMots={}
        resultat=[]
        for langue in langues: 
           
            fichier = open("liste."+langue+".txt", "r")
            #fichier = open("G:\monProjetPython\liste"+langue+".txt", "r")
            t = fichier.read()
        
            expr=re.compile("\W+",re.U) 
            liste = expr.split(t)
            dicoMots[langue]=liste


    
        
        
        listeinc = text.split()
        for langue in langues:
            compteurmots=0
            for mot in listeinc:
                if mot in dicoMots[langue]: 
                    compteurmots+=1
#                    print "pour", langue, "j'ai trouvé", mot
            resultat+=[(compteurmots,langue)]
#        print resultat
        resultat.sort()

        print resultat
        
        return "Cette page est en " + langues[resultat[-1][1]]+"."
        
     
    def nettoie(self,  codehtml):
        

        codehtml=codehtml.replace("\n", " " )
        expr= re.compile("<script.*?></script>", re.U)
        codehtml= expr.sub(" ", codehtml)
        expr=re.compile("<style>.*?</style>")
        codehtml=expr.sub(" ", codehtml)
        codehtml=codehtml.replace("&nbsp;", " ")
        
        expr=re.compile("<.*?>")
        text=expr.sub(" ",codehtml)
        text=re.sub(" +"," ",text)
        return text
        
        
   



if __name__ == "__main__":
     import sys
     app = QtGui.QApplication(sys.argv)
     wnd = MainWindow()
     wnd.show()
     sys.exit(app.exec_())
   

